uses n2_image,n2_vector,n2_matrix,n2_mathe,pivtools2,random;

const bsx=128;
      bsy=128;
      pdens=0.02;
      pintn=10;
      
var ma,mb:tmatrix;
    su,sv:double;
    c,i:longint;

procedure pivimgsave(m:tmatrix;s:string);
var img:timage;
	i,j:longint;
begin
  img.sx:=length(m[0]);
  img.sy:=length(m);
  img.imgtype:=tru;
  img.coltype:=y;
  setlength(img.img.y,img.sy,img.sx);
  for j:=0 to img.sy-1 do for i:=0 to img.sx-1 do img.img.y[img.sy-1-j,i]:=maxi(0,mini(255,round(255*m[j,i])));
  img.maxy:=255;
  pngdump(img,s);
end;

procedure pivuvsave(u,v:double;s:string);
var fo:text;
begin
  assign(fo,s);
  rewrite(fo);
  writeln(fo,u,',',v);
  close(fo)
end;

procedure pivimgmake(diam,oo:double);
var i,j,parti,ii,jj,k:longint;
	ax1,ax2,ay1,ay2,aa1,aa2:tvector;
    x1,x2,y1,y2,d,z1,aa:double;
begin
//velocities;
  su:=8*gleichran-4;
  sv:=8*gleichran-4;
//particles;
  parti:=poissonran(pdens*(bsx+16)*(bsy+16)*(1+oo));
  ax1:=initv(parti);
  ay1:=initv(parti);
  aa1:=initv(parti);
  ax2:=initv(parti);
  ay2:=initv(parti);
  aa2:=initv(parti);
  for i:=0 to parti-1 do
  begin
    x1:=(bsx+16)*gleichran-8;
    y1:=(bsy+16)*gleichran-8;
	x2:=x1;
	y2:=y1;
    x1:=x1-su/2;
    y1:=y1-sv/2;
    x2:=x2+su/2;
    y2:=y2+sv/2;
    ax1[i]:=x1;
    ay1[i]:=y1;
    ax2[i]:=x2;
    ay2[i]:=y2;
	z1:=gleichran*(1+oo);
	aa:=gleichran;
    aa1[i]:=aa*byte(z1<1);
    aa2[i]:=aa*byte(z1>oo);
  end;

  for j:=0 to bsy-1 do for i:=0 to bsx-1 do  
  begin
    ma[j,i]:=0;
	for k:=0 to parti-1 do 
	begin
	  d:=sqr(j+0.5-ay1[k])+sqr(i+0.5-ax1[k]);
	  if d<100 then 
	  begin
	    for jj:=0 to pintn-1 do for ii:=0 to pintn-1 do
		  ma[j,i]:=ma[j,i]+aa1[k]*getairy(sqrt(sqr(i+(ii+0.5)/pintn-ax1[k])+sqr(j+(jj+0.5)/pintn-ay1[k])),diam)/sqr(pintn);
      end;
	end;
    mb[j,i]:=0;
	for k:=0 to parti-1 do 
	begin
	  d:=sqr(j+0.5-ay2[k])+sqr(i+0.5-ax2[k]);
	  if d<100 then 
	  begin
	    for jj:=0 to pintn-1 do for ii:=0 to pintn-1 do
		  mb[j,i]:=mb[j,i]+aa2[k]*getairy(sqrt(sqr(i+(ii+0.5)/pintn-ax2[k])+sqr(j+(jj+0.5)/pintn-ay2[k])),diam)/sqr(pintn);
      end;
	end;
  end; 
end;

begin
  ma:=initm(bsy,bsx);
  mb:=initm(bsy,bsx);
  for c:=0 to 10 do
  begin
    for i:=0 to 99 do
    begin
      pivimgmake(3.0,0.05*c);
      pivimgsave(ma,'ts1_'+chr(ord('0')+c div 10)+chr(ord('0')+c mod 10)+'_'+chr(ord('0')+i div 10)+chr(ord('0')+i mod 10)+'a.png');
      pivimgsave(mb,'ts1_'+chr(ord('0')+c div 10)+chr(ord('0')+c mod 10)+'_'+chr(ord('0')+i div 10)+chr(ord('0')+i mod 10)+'b.png');
      pivuvsave(su,sv,'ts1_'+chr(ord('0')+c div 10)+chr(ord('0')+c mod 10)+'_'+chr(ord('0')+i div 10)+chr(ord('0')+i mod 10)+'.uv');
    end;
  end;
end.
